var L10NStrings = {
PAGE_TITLE: "Office 365 Protection",
KEY1: "Office 365 Protection",
KEY2: "Help",
KEY3: "ScanMail is an on-premise resource and is installed within the corporate network to provide protection to corporate email messages.",
KEY4: "The protection offered by ScanMail in different scenarios (that are based on email direction and receiver/sender account location) is explained below.",
KEY5: "In a scenario where ScanMail cannot provide protection, Trend Micro provides an alternative security service called ",
KEY6: "Cloud App Security",
KEY7: ". Refer to the ",
KEY8: "Trend Micro Cloud App Security",
KEY9: " and its ",
KEY10: "online documentation",
KEY11: " for details.",
KEY12: "Mail Direction: Inbound email messages from outside the corporate network",
KEY13: "Mail Exchanger (MX) Record ",
KEY14: "Centralized Mail Transport Setting",
KEY15: "Protection Offered",
KEY16: "Description",
KEY17: "Details",
KEY18: "Point to: On-premise",
KEY19: "-",
KEY20: "Yes",
KEY21: "ScanMail scans the inbound email message before delivering it to the receiver mailboxes that exist online and/or on-premise server(s).",
KEY22: "Hide details",
KEY23: "Point to: Exchange Online",
KEY24: "Enabled",
KEY25: "If the Centralized Mail Transport is ",
KEY26: "enabled",
KEY27: ", ScanMail scans the inbound email message before delivering it to the receiver mailboxes that exist online and/or on-premise server(s).",
KEY28: "Disabled",
KEY29: "Yes; for on-premise mailboxes",
KEY30: "If the Centralized Mail Transport is ",
KEY31: "disabled",
KEY32: ", and the receiver mailbox is located on the ",
KEY33: "on-premise",
KEY34: " Exchange server, ScanMail can still scan the inbound email message before delivering it to the receiver mailbox. ",
KEY35: "No; for online mailboxes",
KEY36: "If the Centralized Mail Transport is ",
KEY37: "disabled",
KEY38: ", and the receiver mailbox is located on the ",
KEY39: "Microsoft™ Exchange Online ",
KEY40: "(Microsoft™ Office 365), the email message bypasses the on-premise ScanMail server. Therefore, ScanMail ",
KEY41: "CANNOT",
KEY42: " scan it.",
KEY43: "To offer protection to online accounts in such scenario, Trend Micro provides an alternative security service called ",
KEY44: "Mail Direction: Outbound email messages from the corporate network",
KEY45: "Messages From",
KEY46: "On-premise",
KEY47: "If the sender account exists on the on-premise server, ScanMail scans the outbound email message before sending it out from the corporate network.",
KEY48: "Exchange Online",
KEY49: "ScanMail scans the outbound email message before sending it out from the corporate network.",
KEY50: "If the Centralized Mail Transport is ",
KEY51: "disabled",
KEY52: ", and the sender mailbox exists on Exchange server, ScanMail can still scan the outbound email message before sending it out.",
KEY53: "If the Centralized Mail Transport is ",
KEY54: "disabled",
KEY55: ", and the sender account exists on Microsoft™ Exchange Online (Microsoft™ Office 365) server, the email message bypasses the ScanMail server. Therefore, ScanMail ",
KEY56: "CANNOT",
KEY57: " scan the outbound email message before sending out from Exchange Online.",
KEY58: "Mail Direction: Internal email messages within the corporate network",
KEY59: "Sent To",
KEY60: "If both the sender and receiver accounts exist on the on-premise server, ScanMail scans the internal email message before delivering it to the receiver.",
KEY61: "Exchange Online mailbox",
KEY62: "If the sender account exists on the on-premise server, and the receiver account exists on Microsoft™ Exchange Online (Microsoft™ Office 365) server, ScanMail scans this internal email message before delivering it to the receiver.",
KEY63: "If the sender account exists on the Microsoft™ Exchange Online (Microsoft™ Office 365) server and the receiver account exists on the on-premise server, ScanMail scans the internal email message before delivering it to the receiver.",
KEY64: "No",
KEY65: "If both the sender or receiver accounts exist on the Microsoft™ Exchange Online (Microsoft™ Office 365) server, all the communication bypasses the ScanMail server. Therefore, ScanMail ",
KEY66: "CANNOT",
KEY67: " scan these email message.",
KEY68: "In case you have moved all of your mailboxes to Microsoft™ Office 365, you can protect your mailboxes with",
KEY69: "Trend Micro Cloud App Security",
KEY70: ". ",
KEY71: " can provide advanced protection for Microsoft Office 365 services",
KEY72: "Inbound Email: MX Record Points to On-premises Exchange Server",
KEY73: "Inbound Email: Central Mail Transport Enabled, with MX Record Points to Exchange Online",
KEY74: "Inbound Email: Central Mail Transport Disabled, with MX Record Points to Exchange Online, and Send to On-Premises Mailboxes",
KEY75: "Inbound Email: Central Mail Transport Disabled with MX Record Points to Exchange Online, and Sends to Exchange Online Mailboxes",
KEY76: "Outbound Email: Sent from On-premise Exchange Server",
KEY77: "Outbound Email: Sent from Exchange Online with Central Mail Transport Enabled",
KEY78: "Outbound Email: Sent from Exchange Online Central Mail Transport Disabled for On-premise Mailboxes",
KEY79: "Outbound Email: Sent from Exchange Online Central Mail Transport Disabled for Online Mailboxes",
KEY80: "Internal Email: Sent from On-premise Mailboxes to On-premise Mailboxes",
KEY81: "Internal Email: Sent from On-premise Mailboxes to Online Mailboxes",
KEY82: "Internal Email: Sent from Online Mailboxes to On-premise Mailboxes",
KEY83: "Internal Email: Sent from Online mailboxes to Online Mailboxes",
KEY84: "US Region:",
KEY85: "EU Region:",
KEY86: "JP:",
KEY87: "Trend Micro provides a security service, called",
KEY88: "Cloud App Security",
KEY89: "to protect your Office 365 Exchange online, OneDrive for Business, and SharePoint online.",
KEY90: "ScanMail and Cloud App Security work together to protect your on-premises servers and online Exchange services.",
KEY91: "Learn More",
KEY92: "< Back",
KEY93: " for details.",
KEY94: "Log on to the Cloud App Security management console at: "
};
g_L10NVariables.push(L10NStrings);