/* Public Variable */
var oTextRange;
var oElement;
var vBrowser = getBrowser();
var b_version = getBrowserVersion();
var CANCEL_EVENT = false;

function jsFocus(oTarget) {
	if(oTarget.disabled == false)
	{
		oTarget.focus();
		oTarget.select();
	}
}
function getBrowser() {
	var sTemp = "NN";
	if (navigator.userAgent.indexOf("MSIE")>-1 || navigator.userAgent.indexOf("Trident")>-1) { sTemp = "IE"; }
	if (navigator.userAgent.indexOf("Firefox")>-1) { sTemp = "FX"; }
	if (navigator.userAgent.indexOf('Trident')>-1 && navigator.userAgent.indexOf('rv:11')>-1) //IE11
    {
        sTemp = "IE";
    }
	return sTemp;	
}
function getBrowserVersion(){
    var BVersion = null;
    var strBrowser = navigator.userAgent;
    if(vBrowser == "IE"){
       if(strBrowser.indexOf("MSIE")>-1) //IE6, 7, 8, 9 ,10
       {
           var tmpV1 = strBrowser.substring(strBrowser.indexOf("(")+1,strBrowser.indexOf(")"));
           var tmpV2 = tmpV1.split(";");
           for(var i=0;i<tmpV2.length;i++){
                if(tmpV2[i].indexOf("MSIE")>-1){
                    var tmpV3 = tmpV2[i].substring(5,tmpV2[i].length);
                    BVersion =  parseFloat(tmpV3);
                    return BVersion; 
                }
             }
       }
       else
       {
            if (strBrowser.indexOf('Trident')>-1 && strBrowser.indexOf('rv:11')>-1) //IE11
            {
                BVersion = 11;
                return BVersion;
            }
       }
    }
    else if(vBrowser == "FX"){
        BVersion = parseFloat(strBrowser.substring(strBrowser.lastIndexOf("/")+1,strBrowser.length));
        return BVersion;
    }
    else { 
        return BVersion;
    }    
}
function jsCheckBrowser(){
    if(vBrowser == "IE"){
        if (b_version < 6){
            alert(STR_BROWSER_VER_ERR);
        }
    }
    else if(vBrowser == "FX"){
        if(b_version < 3){
            alert(STR_BROWSER_VER_ERR);
        }
    }
    else{
		//TT-286950, Remove CheckBrowser alert detection,
        //alert(STR_BROWSER_SUPPORT);
    }  
}
/* setCurrentPosition: record the current insertion point
 * [tarObj] the current object
 */
function setCurrentPosition(tarObj)
{
	if (document.selection){
	    oTextRange = document.selection.createRange();
	}
	else {return false;}
	oElement = tarObj;
}
/* setUIDisplay: set the UI range display or not
 * [srcState] true/false
 * [tarObj] the target object
 */
function setUIDisplay(srcState,tarObj)
{
	if (tarObj == null) return;
	tarObj.style.display = (srcState)?"":"none";
}
function replaceLastOne(tarObjStr, bFlag)
{
	var strUp = 'up';
	var strDown = 'down';
	var current = tarObjStr.lastIndexOf(strDown);
	if(bFlag) // down to up
	{
		current = tarObjStr.lastIndexOf(strDown);
		tarObjStr = tarObjStr.substring(0,current)+ strUp + tarObjStr.substring(current+strDown.length,tarObjStr.length);
	}else // up to down
	{
		current = tarObjStr.lastIndexOf(strUp);
		tarObjStr = tarObjStr.substring(0,current)+ strDown + tarObjStr.substring(current+strUp.length,tarObjStr.length);
	}
	
	return tarObjStr;
}
/* setUIMoreDisplay: set the More range display or not and change the images
 * [tarObj] the target object
 */
function setUIMoreDisplay(tarObj)
{
	if (tarObj == null) return;
	var strtarObj = document.getElementById(tarObj.id + "_icon").src;
	var bFlag = (document.getElementById(tarObj.id + "_icon").src.search(/more_down/i) > 0)?true:false;
	setUIDisplay(bFlag,document.getElementById(tarObj.id + "_items"));
	if (bFlag){
		strtarObj = replaceLastOne(strtarObj, bFlag);
		//document.getElementById(tarObj.id + "_icon").src = document.getElementById(tarObj.id + "_icon").src.replace(/down/i,"up");
		document.getElementById(tarObj.id + "_icon").src = strtarObj;
		if(tarObj.lastChild.nodeValue){ if(tarObj.lastChild.nodeValue.indexOf("Show") != -1) tarObj.lastChild.nodeValue = " Hide details";}
	} else {
		strtarObj = replaceLastOne(strtarObj, bFlag);
		//document.getElementById(tarObj.id + "_icon").src = document.getElementById(tarObj.id + "_icon").src.replace(/up/i,"down");
		document.getElementById(tarObj.id + "_icon").src = strtarObj;
		if(tarObj.lastChild.nodeValue){ if(tarObj.lastChild.nodeValue.indexOf("Hide") != -1) tarObj.lastChild.nodeValue = " Show details";}
	}
}
/* setUIMoreOver: change the src of icon and css style of word.
 * [tarObj] the target object
 * [bFlag] the flag distinguish between Mouse Over (true) and Mouse Out (false)
 */ 
function setUIMoreOverOut(tarObj,bFlag){
    if (tarObj == null) return;
   if (bFlag){
		document.getElementById(tarObj.id + "_icon").src = document.getElementById(tarObj.id + "_icon").src.replace(/out/i,"over");
		 tarObj.className =  "more-over";
	} else {
		document.getElementById(tarObj.id + "_icon").src = document.getElementById(tarObj.id + "_icon").src.replace(/over/i,"out");
		 tarObj.className =  "more-out";
	}  
}
/* setUITagDisplay: set the Tag range display or not and change the images
 * [index] the tag index => active
 * [count] the total number tag
 * [name] the tag name(description)
 */
var PageCurrentTag; 
function setUITagDisplay(index,count,name)
{
	if (index < 1 && index > count) return;
	if (count < 1) return;
	if (name == "") return;
	PageCurrentTag = name;
	var sId = "";
	for (var i=1; i<=count; i++)
	{
		sId = "Tag" + i;
		if (i==index) {
			document.getElementById(sId).style.backgroundImage = document.getElementById(sId).style.backgroundImage.replace(/inactive/i,"active");
			document.getElementById(sId).innerHTML = name;
			document.getElementById(sId + "_imgS").src = document.getElementById(sId + "_imgS").src.replace(/inactive/i,"active");
			document.getElementById(sId + "_imgE").src = document.getElementById(sId + "_imgE").src.replace(/inactive/i,"active");
			document.getElementById(sId).className = "tabactive";
			setUIDisplay(true,document.getElementById(sId + "_items"));
		} else if (document.getElementById(sId).className == "tabactive") {
			document.getElementById(sId).style.backgroundImage = document.getElementById(sId).style.backgroundImage.replace(/active/i,"inactive");
			document.getElementById(sId).innerHTML = "<a class=\"subnavselect\" href=\"javascript:setUITagDisplay(" + i + "," + count + ",'" + document.getElementById(sId).innerHTML + "');\">" + document.getElementById(sId).innerHTML + "</a>";
			document.getElementById(sId + "_imgS").src = document.getElementById(sId + "_imgS").src.replace(/active/i,"inactive");
			document.getElementById(sId + "_imgE").src = document.getElementById(sId + "_imgE").src.replace(/active/i,"inactive");
			document.getElementById(sId).className = "tabinactive";
			setUIDisplay(false,document.getElementById(sId + "_items"));
		}
	}
}

function setUIFunctionLink(srcState, tarID)
{	
	if (document.getElementById(tarID) != null) {
		document.getElementById(tarID).disabled = (!srcState);
		document.getElementById(tarID).style.cursor = (srcState)? "pointer":"default";
		document.getElementById(tarID).style.color = (srcState)? "":"#999999";
		document.getElementById(tarID).style.textDecoration = (srcState)? "":"none";
	}
	if (document.getElementById(tarID + "_img") != null) { 
		if (!(document.getElementById(tarID + "_img").src.search(/_gray.gif/i) > 0) != srcState) {
			if (srcState) {
			document.getElementById(tarID + "_img").src = document.getElementById(tarID + "_img").src.replace(/_gray.gif/i,".gif");
			document.getElementById(tarID + "_img").style.cursor = "pointer";
			} else {
			document.getElementById(tarID + "_img").src = document.getElementById(tarID + "_img").src.replace(/.gif/i,"_gray.gif");
			document.getElementById(tarID + "_img").style.cursor = "default";
			}
		}
	}
}
function setUIChecked(srcState, tarObj)
{
	if (tarObj) {
		if (tarObj.length == null) {
			if (tarObj.checked!=srcState) {tarObj.click();}
			//tarObj.checked = srcState;
		} else {
			for (var i=0;i<tarObj.length;i++) {
				if (tarObj[i].checked!=srcState && tarObj[i].style.display!="none") {tarObj[i].click();}
				//tarObj[i].checked = srcState;
			}
		}
	}
}
function setUIItemsChecked(oAll,oItems,bFlag) {
	if (oAll == null) { return; }
	if (oItems == null) { return; }
	
	var nCount = 0;
	if (oItems.length == null) {
		if (oItems.checked) nCount++;
		oAll.checked = oItems.checked;
		//oAll.checked = oItems.checked;
	} else {
    	for(var i=0;i<oItems.length;i++) {
		  	if(oItems[i].style.display=="none" || oItems[i].checked) nCount++;
	    }
	    if (bFlag) {	// oAll will be un-checked, when there is more than one item which was un-checked.
		oAll.checked = (nCount == oItems.length) ? 1 : 0;
		} else {		// oAll will be un-checked, when all items were un-checked.
		oAll.checked = (nCount > 0) ? 1 : 0;
		}
  	}
}

// Set the single-select's focus on the one which value equals to strValue.  
function SetSelectFocus(objSelect, strValue)
{
    for(var i=0;i<objSelect.length;i++)
    {
        if(objSelect.options[i].value == strValue)
        {
            objSelect.options[i].selected = true;
            break;
        }
    }
}

/* setMoveItem: move item from source to target object
 * srcObj: source object (text,select)
 * tarObj: target object (text,textarea,select)
 * bRemoveItem: remove the current item
 */
function setUIMoveItem(srcObj, tarObj, bRemoveItem)
{
	if (srcObj == null) return;
	if (tarObj == null) return;

	var nIndex = -1;
	if (srcObj.tagName=="TABLE") {
		// source object is table
		for (var i=srcObj.rows.length-1;i>-1;i--) {
			if (srcObj.rows[i].cells[0].className=="listSelected") {
				nIndex = setUIAddItem(srcObj.rows[i].cells[0].innerHTML, tarObj);
				srcObj.rows[i].cells[0].className = "listNormal";
				if (bRemoveItem) { deleteTableRowByIndex(srcObj,i); }
			}
		}
	} else if (srcObj.type.search(/text/i)>-1) {
		// source object is text
		nIndex = setUIAddItem(srcObj.value, tarObj);
		if (bRemoveItem) { srcObj.value = ""; }
	} else if (srcObj.type.search(/select/i)>-1) {
		// source object is select (list)
		if (srcObj.length == 0) { return; }
		for (var i=srcObj.length-1;i>-1;i--) {
			if (srcObj.options[i].selected) {
				if (tarObj.type.search(/select/i)>-1) {
					nIndex = setUIAddItemWithValue(srcObj.options[i].text,srcObj.options[i].value,tarObj);
				} else {
					nIndex = setUIAddItem(srcObj.options[i].text,tarObj);
				}
				if (!bRemoveItem) srcObj.options[i].selected = false;
			}
		}
		if (bRemoveItem) setUIDelfromList(srcObj);
	}
	return nIndex;
}
/* setUIAddItem: add item into target object
 * srcString: source string
 * tarObj: target object (text,textarea,select)
 */
function setUIAddItem(srcString, tarObj)
{
	if (srcString == "") return;
	if (tarObj == null) return;
	
	var nIndex = -1;
	if (tarObj.type.search(/select/i)>-1) {
		// target object is select (list)
		var oOption = document.createElement("OPTION");
		for (var i=0;i<tarObj.length;i++) {
			if (tarObj.options[i].text == srcString) {return nIndex;}
			if (tarObj.options[i].text.toUpperCase().toString(10) > srcString.toUpperCase().toString(10)) {break;}
		}
		oOption.text = srcString;
		oOption.value = srcString;
		if (vBrowser=="IE" || vBrowser=="FX") 	{ tarObj.options.add(oOption,i); }
		else if (vBrowser=="NN"){ tarObj.add(oOption,tarObj.options[i]); }
		nIndex = i;
	} else if (tarObj.type.search(/text/i)>-1) {
		// target object is text or textarea
		if ((vBrowser=="IE")&&(oElement==tarObj)) {
			oTextRange.text = srcString;
		} else {
			tarObj.value += srcString;
		}
	}
	return nIndex;
}
/* setUIAddItemAndCompareWithoutTrim: add item into target object and dont trim whth space when compare
 * srcString: source string
 * tarObj: target object (text,textarea,select)
 */
function setUIAddItemAndCompareWithoutTrim(srcString, tarObj)
{
	if (srcString == "") return;
	if (tarObj == null) return;
	
	var nIndex = -1;
	if (tarObj.type.search(/select/i)>-1) {
		// target object is select (list)
		var oOption = document.createElement("OPTION");
		for (var i=0;i<tarObj.length;i++) {
			if (tarObj.options[i].value == srcString) {return nIndex;}
			if (tarObj.options[i].value.toUpperCase().toString(10) > srcString.toUpperCase().toString(10)) {break;}
		}
		oOption.text = srcString;
		oOption.value = srcString;
		if (vBrowser=="IE" || vBrowser=="FX") 	{ tarObj.options.add(oOption,i); }
		else if (vBrowser=="NN"){ tarObj.add(oOption,tarObj.options[i]); }
		nIndex = i;
	} else if (tarObj.type.search(/text/i)>-1) {
		// target object is text or textarea
		if ((vBrowser=="IE")&&(oElement==tarObj)) {
			oTextRange.text = srcString;
		} else {
			tarObj.value += srcString;
		}
	}
	return nIndex;
}
/* setUIAddItem_BinarySearch: add item into target object by binary method, assumed array is aecending
 * srcString: source string
 * tarObj: target object (text,textarea,select)
 */
function setUIAddItem_BinarySearch(srcString, tarObj)
{
	if (srcString == "") return;
	if (tarObj == null) return;
	
	var nIndex = -1;
	if (tarObj.type.search(/select/i)>-1) {
		// target object is select (list)
		var src = srcString.toUpperCase().toString(10);

		var low = 0;
		var high = tarObj.length-1;
		while(low <= high)
		{
			var middle = Math.floor((low + high) / 2);
			if (srcString == tarObj.options[middle].text)
			{
				return nIndex;// has existed, return -1
			}
			else if (src < tarObj.options[middle].text.toUpperCase().toString(10))
			{
				high = middle-1;
			}
			else
			{
				low = middle+1;
			}
			//alert('low:'+low+',high:'+high);
		}
		nIndex = low;
		
		var oOption = document.createElement("OPTION");
		oOption.text = srcString;
		oOption.value = srcString;
		if (vBrowser=="IE" || vBrowser=="FX") 	{ tarObj.options.add(oOption,nIndex); }
		else if (vBrowser=="NN"){ tarObj.add(oOption,tarObj.options[nIndex]); }
	} else if (tarObj.type.search(/text/i)>-1) {
		// target object is text or textarea
		if ((vBrowser=="IE")&&(oElement==tarObj)) {
			oTextRange.text = srcString;
		} else {
			tarObj.value += srcString;
		}
	}
	return nIndex;
}
/* setMoveItem: move item from source to target object
 * srcObj: source object (text)
 * tarObj: target object (text,textarea,select)
 * bRemoveItem: remove the current item
 */
function setUIMoveItemWithIndex(index,srcObj, tarObj, bRemoveItem)
{
	if (srcObj == null) return;
	if (tarObj == null) return;

	if (srcObj.tagName=="TABLE") {
		// source object is table
		for (var i=srcObj.rows.length-1;i>-1;i--) {
			if (srcObj.rows[i].cells[0].className=="listSelected") {
				nIndex = setUIAddItem(srcObj.rows[i].cells[0].innerHTML, tarObj);
				srcObj.rows[i].cells[0].className = "listNormal";
				if (bRemoveItem) { deleteTableRowByIndex(srcObj,i); }
			}
		}
	} else if (srcObj.type.search(/text/i)>-1) {
		// source object is text
		setUIAddItemWithIndex(index,srcObj.value, tarObj);
		if (bRemoveItem) { srcObj.value = ""; }
	} 
}
/* setUIAddItem: add item into target object
 * srcString: source string
 * tarObj: target object (text,textarea,select)
 */
function setUIAddItemWithIndex(index,srcString, tarObj)
{
	if (srcString == "") return;
	if (tarObj == null) return;
	
	if (tarObj.type.search(/select/i)>-1) {
		// target object is select (list)
		var oOption = document.createElement("OPTION");
		oOption.text = srcString;
		oOption.value = srcString;
		if (vBrowser=="IE" || vBrowser=="FX") 	{ tarObj.options.add(oOption,index); }
		else if (vBrowser=="NN"){ tarObj.add(oOption,tarObj.options[index]); }
	} else if (tarObj.type.search(/text/i)>-1) {
		// target object is text or textarea
		if ((vBrowser=="IE")&&(oElement==tarObj)) {
			oTextRange.text = srcString;
		} else {
			tarObj.value += srcString;
		}
	}
}
/* setUIAddItemWithValue: add item into target object
 * srcText: text string (display)
 * srcValue: value string
 * tarObj: target object (select)
 */
function setUIAddItemWithValue(srcText, srcValue, tarObj)
{
	if (srcText == "") return;
	if (srcValue== "") return;
	if (tarObj == null) return;
	
	var nIndex = -1;
	if (tarObj.type.search(/select/i)>-1) {
		// target object is select (list)
		var oOption = document.createElement("OPTION");
		for (var i=0;i<tarObj.length;i++) {
		    //for case #630, account name should be sorted as case insensitive 
			if (tarObj.options[i].text.toUpperCase().toString(10) <= srcText.toUpperCase().toString(10)) {}
			else {break;}
		}
		oOption.text = srcText;
		oOption.value = srcValue;
		if (vBrowser=="IE" || vBrowser=="FX") 	{ tarObj.options.add(oOption,i); }
		else if (vBrowser=="NN"){ tarObj.add(oOption,tarObj.options[i]); }
		nIndex = i;
	}
	return nIndex;
}
/* setUIAddItemWithTitle: add item into target object
 * srcText: text string (display)
 * srcValue: value string
 * srcTitle: title string
 * tarObj: target object (select)
 */
function setUIAddItemWithTitle(srcText, srcValue, srcTitle, tarObj)
{
	if (srcText == "") return;
	if (srcValue== "") return;
	if (tarObj == null) return;
	
	var nIndex = -1;
	if (tarObj.type.search(/select/i)>-1) {
		// target object is select (list)
		var oOption = document.createElement("OPTION");
		for (var i=0;i<tarObj.length;i++) {
			if (tarObj.options[i].text.toString(10) > srcText.toString(10)) break;
		}
		oOption.text = srcText;
		oOption.value = srcValue;
		oOption.title = srcTitle;
		if (vBrowser=="IE" || vBrowser=="FX") 	{ tarObj.options.add(oOption,i); }
		else if (vBrowser=="NN"){ tarObj.add(oOption,tarObj.options[i]); }
		nIndex = i;
	}
	return nIndex;
}
/* setUIDelfromList: remove the selected item from list box
 * tarObj: target object (select)
 */
function setUIDelfromList(tarObj)
{
	if (tarObj == null) return;
	for (var i=tarObj.length-1;i>-1;i--) {
		if (tarObj.options[i].selected) {
			tarObj.remove(i);
		}
	}
}
function getSelectedOptionValue(tarObj) {
	var strValue = "";
	if (tarObj == null) return strValue;
	if (tarObj.length == null) {
		if (tarObj.checked) {strValue = tarObj.value;}
	} else {
		for (var i=0;i<tarObj.length;i++) {
		if (tarObj[i].checked) {strValue = strValue + "," + tarObj[i].value;}
		}
		if (strValue.length>0) {strValue = strValue.slice(1,strValue.length);}
	}
	return strValue;
}
/* setDateTimeValue: insert items
 * tarObj: combobox
 * srcString: item list
 */
function setDateTimeValue(tarObj,srcString) {
	if (tarObj == null) {return;}
	if (srcString == "") { return;}
	
	var oString = srcString.split(",");
	var oOption;
	for (var i=0; i<oString.length; i++) {
		oOption = document.createElement("OPTION");
		oOption.text = oString[i];
		oOption.value = oString[i];
		if (vBrowser=="IE" || vBrowser=="FX") 	{ tarObj.options.add(oOption); }
		else if (vBrowser=="NN"){ tarObj.add(oOption,null); }
	}
}
/* setOptionValue: insert items
 * tarObj: combobox
 * srcString: item list
 * bIndex: value is index(true) or text(false)
 */
function setOptionValue(tarObj,srcString,bIndex) {
	if (tarObj == null) {return;}
	if (srcString == "") { return;}
	if (bIndex == null) { bIndex=true; }

	var oString = srcString.split(",");
	var oOption;
	for (var i=0; i<oString.length; i++) {
		oOption = document.createElement("OPTION");
		oOption.text = oString[i];
		if (bIndex) oOption.value = i;
		else oOption.value = oString[i];
		if (vBrowser=="IE" || vBrowser=="FX") 	{ tarObj.options.add(oOption); }
		else if (vBrowser=="NN"){ tarObj.add(oOption,null); }
	}
}

// Added for Event tracking feature, since Username can contains all kinds of special characters like \t, blank space, 
function setOptionValueWithSpecialTag(tarObj,srcString,bIndex) {
	if (tarObj == null) {return;}
	if (srcString == "") { return;}
	if (bIndex == null) { bIndex=true; }

	var oString = srcString.split("<split>");
	var oOption;
	for (var i=0; i<oString.length; i++) {
		var strValue = oString[i];
		strValue = strValue.replace(/<quat>/g, "\"");
		strValue = strValue.replace(/<left>/g, "<");
		
		setUIAddItem(strValue, tarObj);
	}
}

function setOptionValueEx(tarObj,strDisplay,strValue) {
	if (tarObj == null) {return;}
	if (strDisplay == "") { return;}
	if (strValue == "") { return;}
	
	var oDisplay = strDisplay.split(",");
	var oValue = strValue.split(",");
	if(oDisplay.length > oValue.length) { return; }
	
	var oOption;
	for (var i=0; i<oDisplay.length; i++) {
		oOption = document.createElement("OPTION");
		oOption.text = oDisplay[i];
		oOption.value = oValue[i];
		if (vBrowser=="IE" || vBrowser=="FX") 	{ tarObj.options.add(oOption); }
		else if (vBrowser=="NN"){ tarObj.add(oOption,null); }
	}
}
/* setDeviceOptionValueWithAttrib: insert option items in the Cisco Devices listbox
 * tarObj: listbox
 * srcString: item list
 * srcAttrib: attrib list for item list
 * bIndex: value is index(true) or text(false)
 */
function setDeviceOptionValueWithAttrib(tarObj,srcString,srcAttrib,bIndex) {
	if (tarObj == null) {return;}
	if (srcString == "") { return;}
	if (srcAttrib == "") { return;}
	if (bIndex == null) { bIndex=true; }

	var oString = srcString.split(",");
	var oAttrib = srcAttrib.split(",");

	if ( oString.length != oAttrib.length )
	{
		alert(STR_ERR_INIT_PAGE_FAIL);
		window.close();
	}

	var oOption;
	for (var i=0; i<oString.length; i++) {
		oOption = document.createElement("OPTION");
		oOption.text = oString[i];
		oOption.setAttribute("DeviceType", oAttrib[i]);
		if (bIndex) oOption.value = i;
		else oOption.value = oString[i];
		tarObj.options.add(oOption);
	}
}
/* setDateTimeFormat: set the datetime format  [mm/dd/yyyy hh:mm]
 * tarString: target object (select)
 */
function setDateTimeFormat(srcString)
{
	if (srcString == "") { return; }
	
	var strResult = "";
	var strTemp = "";
	
	var dtTemp = new Date(srcString);
	var sMon = (dtTemp.getMonth()+1).toString();
	var	sDay = dtTemp.getDate().toString();
	
	if (sMon.length==1) { sMon = "0" + sMon; }
	if (sDay.length==1) { sDay = "0" + sDay; }
	srcString = sMon + "/" + sDay + "/" + dtTemp.getFullYear();
	
	var sHH = dtTemp.getHours().toString();
	var sMM = dtTemp.getMinutes().toString();
	
	if (sHH.length==1) { sHH = "0" + sHH; }
	if (sMM.length==1) { sMM = "0" + sMM; }
	srcString = srcString + " " + sHH + ":" + sMM;
	
	return srcString;
}

/* Transfer datetime format from Server Setting to our program standard format
 * mm/dd/yyyy is the program standard format
 */
function setDateTimeFormatToProgramStandard(srcString,txtLocalStr,vTwoDigitYMax)
{	
	var tempValue = new Array(3);
	var strDateFormat = new Array(3);
	var sepText = new Array("","","");
	var i,k;
	var chkFlag = false;
	var vYear,vMonth,vDay;
	var tempSrcString;
    txtLocalStr = txtLocalStr.replace(/M+/g,"M");
	txtLocalStr = txtLocalStr.replace(/d+/g,"d");
	txtLocalStr = txtLocalStr.replace(/y+/g,"y");
	k = 0;
	for(i=0;i<txtLocalStr.length;i++){
	    if(txtLocalStr.substr(i,1)!="M" && txtLocalStr.substr(i,1)!="d" && txtLocalStr.substr(i,1)!="y"){
	        sepText[k] = sepText[k] + txtLocalStr.substr(i,1);
	        chkFlag = true;
	    } else {
	        if(chkFlag){
				k++;
				chkFlag = false;
			}
	    }
	}
	tempValue[0] = srcString.substring(0,srcString.indexOf(sepText[0]));
	tempSrcString = srcString.substring(srcString.indexOf(sepText[0])+sepText[0].length);
	tempValue[1] = tempSrcString.substring(0,tempSrcString.indexOf(sepText[1]));
	tempSrcString = tempSrcString.substring(tempSrcString.indexOf(sepText[1])+sepText[1].length);
	if(sepText[2].length>0){
		tempValue[2] = tempSrcString.substring(0,tempSrcString.indexOf(sepText[2]));
	}
	else{
		tempValue[2] = tempSrcString;
	}

	k = 0;
	for(i=0;i<txtLocalStr.length;i++){
		if(txtLocalStr.substr(i,1)=="M" || txtLocalStr.substr(i,1)=="d" || txtLocalStr.substr(i,1)=="y"){
			strDateFormat[k] = txtLocalStr.substr(i,1);
			k++;
		}
	}
	
	for(i=0;i<3;i++){
		switch(strDateFormat[i]){
			case "M":
				vMonth = tempValue[i];
				break;
			case "d":
				vDay = tempValue[i];
				break;
			case "y":
				if(tempValue[i].length == 2){
					vYear = (parseInt(tempValue[i])>parseInt(vTwoDigitYMax.substr(2,2)))?"19" + tempValue[i]:"20" + tempValue[i];
				} else {
					vYear = tempValue[i];
				}
				break;
		}
	}
	//var tempDate = new Date(vYear,vMonth-1,vDay);
	//vYear = tempDate.getFullYear();
	//vMonth = (tempDate.getMonth()+1);
	vMonth = (vMonth.toString.length == 1)?"0" + vMonth:vMonth;
	//vDay = tempDate.getDate();
	vDay = (vDay.toString.length == 1)?"0" + vDay:vDay;
	
	var sDate = vMonth + "/" + vDay + "/" + vYear;

	return sDate;
}

/* Transfer datetime format from our program standard format to Server Setting
 * mm/dd/yyyy is the program standard format
 */
function setDateTimeFormatToServerSetting(srcString,txtLocalStr)
{
	sDate = srcString;	
	sDateAry = sDate.split("/");
	var vYear, vMonth, vDay;	
	
	if(txtLocalStr.indexOf("MM")==-1 && sDateAry[0].substr(0,1)==0){
		vMonth = sDateAry[0].substr(1,1);
	} else {
		vMonth = sDateAry[0];
	}
	
	if(txtLocalStr.indexOf("dd")==-1 && sDateAry[1].substr(0,1)==0){
		vDay = sDateAry[1].substr(1,1);
	} else {
		vDay = sDateAry[1];
	}
	
	if(txtLocalStr.indexOf("yyyy")==-1){
		vYear = sDateAry[2].substr(2,2);
	} else {
		vYear = sDateAry[2];
	}
	
	txtLocalStr = txtLocalStr.replace(/M+/g,"M");
	txtLocalStr = txtLocalStr.replace(/d+/g,"d");
	txtLocalStr = txtLocalStr.replace(/y+/g,"y");
	vLocalDate = txtLocalStr;
	vLocalDate = vLocalDate.replace("M",vMonth);
	vLocalDate = vLocalDate.replace("d",vDay);
	vLocalDate = vLocalDate.replace("y",vYear);	
	
	sDate = vLocalDate;
	return sDate;
}

/* setDateTimeCGIFormat: set the datetime format for CGI [YYYY-MM-DD hh:mm:ss]
 * tarString: target object (select)
 */
function setDateTimeCGIFormat(srcString)
{
	if (srcString == "") { return; }
	
	var strResult = "";
	var strTemp = "";
	
	var dtTemp = new Date(srcString);
	var sMon = (dtTemp.getMonth()+1).toString();
	var	sDay = dtTemp.getDate().toString();
	
	if (sMon.length==1) { sMon = "0" + sMon; }
	if (sDay.length==1) { sDay = "0" + sDay; }
	srcString = dtTemp.getFullYear() + "-" + sMon + "-" + sDay;
	
	var sHH = dtTemp.getHours().toString();
	var sMM = dtTemp.getMinutes().toString();
	var sSS = dtTemp.getSeconds().toString();
	
	if (sHH.length==1) { sHH = "0" + sHH; }
	if (sMM.length==1) { sMM = "0" + sMM; }
	if (sSS.length==1) { sSS = "0" + sSS; }
	srcString = srcString + " " + sHH + ":" + sMM + ":" + sSS;
	
	return srcString;
}
/* setOption2Selected: select all item of target object
 * tarObj: target object (select)
 */
function setOption2Selected(tarObj)
{
	if (tarObj == null) { return; }
 	for(var i=0;i<tarObj.length;i++)
		tarObj.options[i].selected = true;
}
/* setOption2Selected_2: select all item of target object
 * if no item in select, add an empty option(empty id and empty value) to select item
 * tarObj: target object (select)
 */
function setOption2Selected_2(tarObj)
{
	if (tarObj == null) { return; }		
	if (tarObj.length == 0) { 
		var option = new Option("", "");
		option.selected = true;
		tarObj.options[0] = option;
		return;
	}
	for(var i=0;i<tarObj.length;i++)
		tarObj.options[i].selected = true;
}
/* setInitTreeView: init tree view
 * nLevel: default expend level (0~4), total 5 level
 */
function setInitTreeView(nDisplayLevel) {
	if (nDisplayLevel == null || nDisplayLevel == "" || nDisplayLevel < 0) { nDisplayLevel = 0; }
	if (nDisplayLevel > 4) { nDisplayLevel = 4; }
	
	var oTable = document.getElementById("tabTreeView");
	setInitTreeViewDisplay(oTable,nDisplayLevel,1);
}
/* setInitTreeViewDisplay: init tree view display/hidden this level
 * nLevel: default expend level (0~4), total 5 level
 */
function setInitTreeViewDisplay(oTable,nDisplayLevel,nLevel) {
	for (var i=0;i<oTable.rows.length;i++){
		if (oTable.rows[i].id != "") {
			if (nDisplayLevel < nLevel) { setTreeView(oTable.rows[i].id.replace("_tab","")); }
			oTable = oTable.rows[i].cells[1].firstChild;
			setInitTreeViewDisplay(oTable,nDisplayLevel,nLevel+1);
		}
	}	
}
/* setTreeView: set the group/folder's status
 * tarObj: target group/folder name
 */
function setTreeView(tarId) {
	var bFlag = (document.getElementById(tarId + "_tab").style.display == "") ? false:true;
	
	if (bFlag) {
		document.getElementById(tarId + "_tab").style.display = "";
		document.getElementById(tarId + "_tree").src = document.getElementById(tarId + "_tree").src.replace(/plus/i,"minus");
		document.getElementById(tarId + "_icon").src = document.getElementById(tarId + "_icon").src.replace(/close/i,"open");
	} else {
		document.getElementById(tarId + "_tab").style.display = "none";
		document.getElementById(tarId + "_tree").src = document.getElementById(tarId + "_tree").src.replace(/minus/i,"plus");
		document.getElementById(tarId + "_icon").src = document.getElementById(tarId + "_icon").src.replace(/open/i,"close");
	}
}
/* getTreeEntityValue: get all selected items, excluding grayout items
 * tarObj: target object (checkbox)
 */
function getTreeEntityValue(tarObj) {
	// get the selected item value
	var strValue = "";
	if (tarObj == null) return strValue;
	if (tarObj.length == null) {
		if (tarObj.checked) {strValue = tarObj.value;}
	} else {
		for (var i=0;i<tarObj.length;i++) {
			if (tarObj[i].checked) {
				if ((vBrowser=="IE" && tarObj[i].style.filter=="") || (vBrowser=="FX" && tarObj[i].style.backgroundColor=="") || (vBrowser=="NN" && tarObj[i].style.backgroundColor==""))
				strValue = strValue + "|" + tarObj[i].value;
			}
		}
		if (strValue.length>0) {strValue = strValue.slice(1,strValue.length);}
	}
	return strValue;
}
/* getChkSelectedStatus: get amount of checkboxes and status of selected
 * tarObj: target object (checkbox)
 * If select all, return ([amount of checkboxes],"selectall")
 * If select a certain of items, return ([amount of checkboxes],[selected index1, selected index2, ....])
 * If there is not item selected, return ([amount of checkboxes],"selectnone")
 * If checkbox does not exist, return null
 */
function getChkSelectedStatus(tarObj) {
	// get the selected item value
	var vLen = "";
	var strIndex = "";
	var fSelectAll = true;
	var reString = "";
	if (tarObj == null) return null;
	if (tarObj.length == null) {
		vLen = 1;
		strIndex = (tarObj.checked)?",selectall":",selectnone";
	} else {
		vLen = tarObj.length;
		for (var i=0;i<vLen;i++) {
			if (tarObj[i].checked) {
				strIndex = strIndex + "," + i;
			}
			else {
			    fSelectAll = false;
			}
		}
	}
	
	if (fSelectAll)
		 return "selectall";
		 
	if (strIndex == "")
		 return "selectnone";

	return (vLen + strIndex);
}
/* setTreeEntityValue: set the specified items to be selected
 * tarObj: target object (checkbox)
 */
function setTreeEntityValue(tarGID) {
	// set the selected item value
	for(var i=0;i<document.fmMain.chkEntity.length;i++) {
		if(document.fmMain.chkEntity[i].value == tarGID) { setTreeEntityStatus(document.fmMain.chkEntity[i].id,true); }
	}
}
/* setTreeEntityStatus: set the related items to be selected automatically
 * tarObj: target object (checkbox)
 */
function setTreeEntityStatus(tarId,bFlag) {
	if (document.fmMain.chkEntity.length == null) { return; }
	document.getElementById(tarId).checked = bFlag;
	if (vBrowser=="IE") {document.getElementById(tarId).style.filter = "";}
	else if (vBrowser=="FX") {document.getElementById(tarId).style.backgroundColor = "";}
	else if (vBrowser=="NN") {document.getElementById(tarId).style.backgroundColor = "";}

	var sItem;
	var nItem;
	var oItemName = document.getElementById(tarId).title.split("|");
	var nItemAll = new Array(oItemName.length-1);
	var nItemSelected = new Array(oItemName.length-1);
	var i, j;

	for (i=oItemName.length-1;i>-1;i--) {
		nItemAll[i] = 0;
		nItemSelected[i] = 0;
	}

	for (i=document.fmMain.chkEntity.length-1;i>-1;i--) {
		if (document.fmMain.chkEntity[i].title != "") {
			if (document.getElementById(tarId).title.indexOf(document.fmMain.chkEntity[i].title)>-1) {
				sItem = document.fmMain.chkEntity[i].title.split("|");
				for (j=0;j<sItem.length;j++) { nItemAll[j]++; }
				if (document.fmMain.chkEntity[i].checked){
					if ((vBrowser=="IE" && document.fmMain.chkEntity[i].style.filter=="") || 
					    (vBrowser=="FX" && document.fmMain.chkEntity[i].style.backgroundColor=="") ||
						(vBrowser=="NN" && document.fmMain.chkEntity[i].style.backgroundColor=="")) {
						for (j=0;j<sItem.length;j++) { nItemSelected[j]++; }
					}
				}
			} else if (document.fmMain.chkEntity[i].id.indexOf(tarId)>-1) {
				if (vBrowser=="IE") {document.fmMain.chkEntity[i].style.filter = "";}
				else if (vBrowser=="FX") {document.fmMain.chkEntity[i].style.backgroundColor = "";}
				else if (vBrowser=="NN") {document.fmMain.chkEntity[i].style.backgroundColor = "";}
				document.fmMain.chkEntity[i].checked = document.getElementById(tarId).checked;
			}
		}
	}

	sItem = "";
	for (i=0;i<oItemName.length;i++) {
		if (i>0) {sItem = sItem + "|";}
		sItem = sItem + oItemName[i];
		if (sItem == "") { break; }	// when click the root item.

		if ((i<oItemName.length-1) && (nItemAll[i+1]==nItemSelected[i+1])) {
			if ((vBrowser=="IE" && document.getElementById("chk"+sItem).style.filter!="") || 
			    (vBrowser=="FX" && document.getElementById("chk"+sItem).style.backgroundColor!="") ||
				(vBrowser=="NN" && document.getElementById("chk"+sItem).style.backgroundColor!="")) {
				nItemSelected[i]++;
			}
		}
		if (vBrowser=="IE") {document.getElementById("chk"+sItem).style.filter = "";}
		else if (vBrowser=="FX") document.getElementById("chk"+sItem).style.backgroundColor = "";
		else if (vBrowser=="NN") document.getElementById("chk"+sItem).style.backgroundColor = "";
		if (nItemSelected[i] == 0) {
			document.getElementById("chk"+sItem).checked = false;
		} else {
			document.getElementById("chk"+sItem).checked = true;
			if (nItemAll[i] > nItemSelected[i]) {
				if (vBrowser=="IE") {document.getElementById("chk"+sItem).style.filter = "progid:DXImageTransform.Microsoft.Wave(Add='false', LightStrength=30, Phase=60, Strength=0, Freq=20)";}
				else if (vBrowser=="FX") {document.getElementById("chk"+sItem).style.backgroundColor = "#BBBBBB";}
				else if (vBrowser=="NN") {document.getElementById("chk"+sItem).style.backgroundColor = "#BBBBBB";}
			}
		}
	}
}
/* ================================================================================== */
/* COMMON STRING FUNCTION                                                             */
/* ================================================================================== */
function setTrim(srcString) {
	srcString = setLTrim(srcString);
	srcString = setRTrim(srcString);
  	return srcString;
}
function setLTrim(srcString) {
	while (srcString.substring(0,1) == ' ') {
    srcString = srcString.substring(1,srcString.length);
  	}
  	return srcString;
}
function setRTrim(srcString) {
	while (srcString.substring(srcString.length-1,srcString.length) == ' ') {
    srcString = srcString.substring(0,srcString.length-1);
  	}
  	return srcString;
}
function setHTMLString(srcString) {
	srcString = srcString.replace("&","&amp;");
	srcString = srcString.replace(" ","&nbsp;");
	srcString = srcString.replace("<","&lt;");
	srcString = srcString.replace(">","&gt;");
	srcString = srcString.replace(String.fromCharCode(9),"&nbsp;&nbsp;&nbsp;&nbsp;");
	return srcString;
}
function escapeHTMLString(srcString) {
    var srcStr=srcString;
    //replace all
    do{
        srcString=srcStr;
        srcStr = srcString.replace("&quot;","\""); 
    }while(srcString!=srcStr);
    do{
        srcString=srcStr;
	    srcStr = srcString.replace("&amp;","&");
	}while(srcString!=srcStr);
	do{
        srcString=srcStr;
	    srcStr = srcString.replace("&nbsp;&nbsp;&nbsp;&nbsp;",String.fromCharCode(9));;
	}while(srcString!=srcStr);
	do{
        srcString=srcStr;
	    srcStr = srcString.replace("&nbsp;"," ");
	}while(srcString!=srcStr);
	do{
        srcString=srcStr;
	    srcStr = srcString.replace("&lt;","<");
	}while(srcString!=srcStr);
	do{
        srcString=srcStr;
	    srcStr = srcString.replace("&gt;",">");
	}while(srcString!=srcStr);
	return srcString;
}
/* ================================================================================== */
/* COMMON LISTBOX FUNCTION                                                            */
/* ================================================================================== */
/* oList	 : Listbox object
 * oInnerDiv : Inner Div
 * oOuterDiv : Outer Div
 */
function setListboxUI_old(oList,oInnerDiv,oOuterDiv) {
	oList.style.display = (oList.options.length==0)?"none":"";
	if (oList.options.length==0) {
		oInnerDiv.style.width = 0;
		oInnerDiv.style.height = 0;
		return;
	}
	var nRatio = (vBrowser=="IE")? 3:2;
	var nScroll = (vBrowser=="IE")? 18:15;
	if (vBrowser=="IE") {
		oList.size = oList.options.length+1;
	} else {
		oInnerDiv.style.width = null;
		oInnerDiv.style.height = null;
	
		var nHeight = (oList.options[0].offsetHeight)*(oList.options.length);

		oList.style.height = nHeight+nRatio*2;
	}
	var nScrollOuter = (oList.offsetHeight > oOuterDiv.offsetHeight+2*nRatio)?nScroll:0;
	nScroll = (vBrowser=="IE")? 0:15;
	if (vBrowser == "IE"){
	    if (oList.offsetWidth < oOuterDiv.offsetWidth+nRatio*2-nScrollOuter+nScroll) {
		    oList.style.width = oOuterDiv.offsetWidth+nRatio*2-nScrollOuter+nScroll;
	    }
	}else{
	    if (oList.offsetWidth < oOuterDiv.offsetWidth+nRatio-nScrollOuter+nScroll) {
		    oList.style.width = oOuterDiv.offsetWidth+nRatio-nScrollOuter+nScroll; 
		}	
	}
	oList.style.top = -1*nRatio;
	oList.style.left = -1*nRatio;
	if((oList.offsetWidth-nRatio*2-nScroll)>=0)
	   oInnerDiv.style.width = oList.offsetWidth-nRatio*2-nScroll;
	if((oList.offsetHeight-nRatio*2)>=0)   
	  oInnerDiv.style.height = oList.offsetHeight-nRatio*2;
}
function setListboxUI(oList,oInnerDiv,oOuterDiv) {
	oList.style.display = (oList.options.length==0)?"none":"";
	if (oList.options.length==0) {
		oInnerDiv.style.width = 0;
		oInnerDiv.style.height = 0;
		return;
	}
	var nRatio = (vBrowser=="IE")? 2:2;
	var nScroll = (vBrowser=="IE")? 0:19;
	
	oList.size = oList.options.length+1;
	oList.style.top = -1*nRatio;
	oList.style.left = -1*nRatio;
	if (oList.offsetWidth-nRatio*2-nScroll < oOuterDiv.offsetWidth) {
		oList.style.width = oOuterDiv.offsetWidth+nRatio*2+nScroll;
	}
	if((oList.offsetWidth-nRatio*2-nScroll)>=0)
		oInnerDiv.style.width = oList.offsetWidth-nRatio*2-nScroll;
	if((oList.offsetHeight-nRatio*2)>=0)
		oInnerDiv.style.height = oList.offsetHeight-nRatio*2;
}


/* ================================================================================== */
/* COMMON UI FUNCTION                                                                 */
/* ================================================================================== */
/* setClickDisabled: disable the window click feature
 */
function setClickDisabled() {
	return false;
}
function checkPageStatus(e) {
	e = (vBrowser=="IE")?window.event:e;
	var oElm = (vBrowser=="IE")? e.srcElement:e.target.parentNode;
	var oTag = oElm.tagName;
	var bCancel = CANCEL_EVENT;
	
	// Cancel the event when A(link) + shift
	if (oTag=="A" && e.shiftKey) bCancel = true;

	if (bCancel) {
		if (vBrowser=="IE") e.returnValue = false;
		else e.preventDefault();
	}
}
/* ================================================================================== */
/* COMMON CALENDAR FUNCTION                                                           */
/* ================================================================================== */
/* getCalendar: pop-up the calendar window and return the selected value
 * oIframe: target frames name
 * oElm: target object (text)
 */
function getCalendar(oIframe,oElm,StrDateFormat,vSvrTwoDigitYMax) {
	if (oElm.value!=""){
		tempDate = (StrDateFormat == null)?oElm.value:setDateTimeFormatToProgramStandard(oElm.value,StrDateFormat,vSvrTwoDigitYMax);
		if (!checkDateTimeFormat(tempDate,"",StrDateFormat)){
			oElm.value = "";
			tempDate = "";
		}
	}else{
		tempDate = "";
	}
	var nX = document.getElementById(oElm.id+"_img").offsetLeft;
	var nY = document.getElementById(oElm.id+"_img").offsetTop;
	oIframe.initPage(oElm.id,tempDate,nX,nY,StrDateFormat);
}

/**

All of following 3 functions can only be called from outer frame which includes calendar-new.htm.

Here is what an outer looks like
<div id="divCalendar" name="divCalendar" style="position:absolute;width:0;height:0;overflow:auto;left:-10000px;">
  <iframe id="ifmCalendar" name="ifmCalendar" src="html/calendar-new.htm" frameBorder="0" style="width:0;height:0"></iframe>
</div>
 
**/
function jsCloseCalendar() {
	document.getElementById("divCalendar").style.width = 0;
	document.getElementById("divCalendar").style.height = 0;
	document.getElementById("ifmCalendar").style.width = 0;
	document.getElementById("ifmCalendar").style.height = 0;
}

function jsGetCalendarFrom()
{
	document.getElementById("ifmCalendar").style.width = 245;
	document.getElementById("ifmCalendar").style.height = 200;
	getCalendar(window.ifmCalendar,document.fmMain.txtDateFrom_display,vSvrDateFormat,vSvrTwoDigitYearMax);
}

function jsGetCalendarTo()
{
	document.getElementById("ifmCalendar").style.width = 245;
	document.getElementById("ifmCalendar").style.height = 200;
	getCalendar(window.ifmCalendar,document.fmMain.txtDateTo_display,vSvrDateFormat,vSvrTwoDigitYearMax);
}

function jsGetCalendarScheduleDate()
{	
	document.getElementById("ifmCalendar").style.width = 245;
	document.getElementById("ifmCalendar").style.height = 200;
	getCalendar(window.ifmCalendar,document.fmMain.txtScheduleDate,vSvrDateFormat,vSvrTwoDigitYearMax)
}

/* ================================================================================== */
/* COMMON TOOLTIP FUNCTION                                                            */
/* ================================================================================== */
/* sFrame : iFrame name
 * oMark  : icon object
 * nWidth : tooltip width
 * nHeight: tooltip height
 * sTitle : tooltip title
 * sContent : tooltip content
 */
function hideToolTip(sFrame) {
	document.getElementById(sFrame).style.width=0;
	document.getElementById(sFrame).style.height=0;
}
function showToolTip(sFrame,oMark,nWidth,nHeight,sTitle,sContent) {
	var nTop  = 0;
	var nLeft = 0;
	var nPadding = 2;
	var nScroll  = (vBrowser=="NN")?15:18;
	var yScroll  = document.body.scrollTop;
	var nW_Width = document.documentElement.offsetWidth;
	var nW_Height= (vBrowser=="FX")?window.innerHeight:document.documentElement.offsetHeight;
	nW_Height = nW_Height +  yScroll;
	
	if (nW_Height -(nHeight+nPadding)<0) {
		nTop = 0;
	} else if (nW_Height-(nHeight)-(oMark.offsetTop+oMark.offsetHeight+nPadding)>=0) {
		nTop = oMark.offsetTop+oMark.offsetHeight+nPadding;
	} else {
		nTop = nW_Height-(nHeight+nPadding)-nScroll;
	}
	if (nW_Width-(nWidth+nPadding)<0) {
		nLeft = 0;
	} else if (nW_Width-(nWidth)-(oMark.offsetLeft+oMark.offsetWidth+nPadding)>=0) {
		nLeft = oMark.offsetLeft+oMark.offsetWidth+nPadding;
	} else {
		nLeft = nW_Width-(nWidth+nPadding)-nScroll;
	}
	if ((oMark.offsetLeft+oMark.offsetWidth>nLeft && oMark.offsetLeft<nLeft+nWidth) && 
		(oMark.offsetTop+oMark.offsetHeight>nTop && oMark.offsetHeight<nTop+nHeight)) {
		if (oMark.offsetTop-(nHeight+nPadding)>0) {
			nTop = oMark.offsetTop-(nHeight+nPadding);
		} else if (oMark.offsetLeft-(nWidth+nPadding)>0) {
			nLeft = oMark.offsetLeft-(nWidth+nPadding);
		}
	}
	document.getElementById(sFrame).style.top=nTop;
	document.getElementById(sFrame).style.left=nLeft;
	document.getElementById(sFrame).style.width=nWidth;
	document.getElementById(sFrame).style.height=nHeight;
	window.frames[sFrame].jsSetToolTip(sTitle,sContent);
}
function showToolTip1(e,sFrame,nWidth,nHeight,sTitle,sContent) {
	if (sTitle=="") return;
	if (sContent=="") return;
	
	var nTop  = 0;
	var nLeft = 0;
	var nPadding = 12;
	var nScroll  = (vBrowser=="NN")?15:18;
	var yScroll  = document.body.scrollTop;
	var nW_Width = document.documentElement.offsetWidth;
	var nW_Height= (vBrowser=="FX")?window.innerHeight:document.documentElement.offsetHeight;
	nW_Height = nW_Height +  yScroll;
	
	if (nW_Height-(nHeight+nPadding+nScroll)<0) {
		nTop = 0;
	} else if (nW_Height-(nHeight)-(e.clientY+nPadding+nScroll)>=0) {
		nTop = e.clientY+nPadding;
	} else {
		nTop = nW_Height-(nHeight+nPadding)-nScroll;
	}
	if (nW_Width-(nWidth+nPadding+nScroll)<0) {
		nLeft = 0;
	} else if (nW_Width-(nWidth)-(e.clientX+nPadding+nScroll)>=0) {
		nLeft = e.clientX+nPadding;
	} else {
		nLeft = nW_Width-(nWidth+nPadding)-nScroll;
	}
	document.getElementById(sFrame).style.top=nTop;
	document.getElementById(sFrame).style.left=nLeft;
	document.getElementById(sFrame).style.width=nWidth;
	document.getElementById(sFrame).style.height=nHeight;
	window.frames[sFrame].jsSetToolTip(sTitle,sContent);
}
/* ================================================================================== */
/* COMMON TABLE FUNCTION                                                              */
/* ================================================================================== */
/* insertTableRow: insert new row into target table
 * oTable : target table object
 * sText  : new item's text
 * sValue : new item's value
 * nSort  : 1(asc), -1(desc), 0(insert into first), other(no sorting)
 */
function insertTableRow(oTable,sText,sValue,nSort) {
	if (oTable == null || sText == "") { return; }
	
	var nIndex = oTable.rows.length;
	switch(nSort) {
		case 0: // first
			nIndex=0;
			break;
		case 1:	// asc
			for (var i=0;i<oTable.rows.length;i++) {
			if (oTable.rows[i].cells[0].innerHTML > sText) { nIndex=i; break; }
			}
			break;
		case -1:// desc
			for (var i=0;i<oTable.rows.length;i++) {
			if (oTable.rows[i].cells[0].innerHTML < sText) { nIndex=i; break; }
			}
			break;
	}
	var oRow = oTable.insertRow(nIndex);
	var oCell = oRow.insertCell(0);
	oCell.className = "listNormal";
	oCell.innerHTML = sText;
	oCell.title = sValue;
}
/* deleteTableRowByValue: remove row from target table, according to it's value
 * oTable : target table object
 * sValue : target item's value
 */
function deleteTableRowByValue(oTable,sValue) {
	if (oTable == null) { return; }
	if (sValue.length != "") {
		for (var i=0;i<oTable.rows.length;i++) {
			if (oTable.rows[i].cols[0].title == sValue) {
				deleteTableRowByIndex(oTable,i);
			}
		}
	}
}
/* deleteTableRowByIndex: remove row from target table, according to it's index
 * oTable : target table object
 * nIndex : target item's index
 */
function deleteTableRowByIndex(oTable,nIndex) {
	if (oTable == null) { return; }
	if (nIndex > -1 && nIndex < oTable.rows.length) {
		oTable.deleteRow(nIndex);
	}
}
/* setTableRowClick: imitate the onclick event situation of the select object
 */
function setTableRowClick(e) {
	if (vBrowser == "IE") {
		var oCell = event.srcElement;
	} else {
		var oCell = e.target;
		if (oCell == "[object Text]") { oCell = oCell.parentNode; }
	}
	oCell.className = (oCell.className=="listNormal")?"listSelected":"listNormal";
}

/* ================================================================================== */
/* COMMON CHECKING FUNCTION                                                           */
/* ================================================================================== */
/* checkDateTimeFormat: To validate string is legal date time format
 * string: mm/dd/yyyy
 */
function checkDateTimeFormat(string,message,StrDateFormat)
{
	try {
		var dtAry = string.split("/"); // dtAry[0] is month; dtAry[1] is day, and dtAry[2] is year.		
		var minDate = new Date(INT_NMIN_DATE);
		var maxDate = new Date(INT_NMAX_DATE);
		var dtTemp = new Date(string);
		var maxDayinFebruary = (((dtAry[2] % 4 == 0) && ( (!(dtAry[2] % 100 == 0)) || (dtAry[2] % 400 == 0))) ? 29 : 28 );
		
		if(isNaN(dtAry[0]) || dtAry[0]<1 || dtAry[0]>12) {throw "";}
		if(isNaN(dtAry[1]) || dtAry[1]<1 || dtAry[1]>31 || (dtAry[0]==2 && dtAry[1]>maxDayinFebruary)) {throw "";}
		if(isNaN(dtAry[2]) || dtAry[2]<minDate.getFullYear() || dtAry[2]>maxDate.getFullYear()) {throw "";}		
		if (dtTemp < minDate) { throw "";}
		if (dtTemp > maxDate) { throw "";}

		return true;
	} catch(e) {
		if (message.length){
		if(StrDateFormat!=null){
				temp_NMIN_DATE = setDateTimeFormatToServerSetting(INT_NMIN_DATE,StrDateFormat);
				temp_NMAX_DATE = setDateTimeFormatToServerSetting(INT_NMAX_DATE,StrDateFormat);
				message = message.replace(INT_NMIN_DATE,temp_NMIN_DATE);
				message = message.replace(INT_NMAX_DATE,temp_NMAX_DATE);
			} 
			alert(message);
		}
		return false;
	}
}
function checkPRFormat(string,message)
{
	if (string == "") return true;
	
	var re = /^([a-zA-Z]{2})\-([0-9a-zA-Z]{4})\-([0-9a-zA-Z]{5})\-([0-9a-zA-Z]{5})\-([0-9a-zA-Z]{5})\-([0-9a-zA-Z]{5})\-([0-9a-zA-Z]{5})$/;
	if (re.test(string))
		return true;

	if (message.length)
		alert(message);
	return false;
}
function checkEmailPatternFormat(string,message)
{
	if (string == "") return true;
	
	var re = /^[0-9a-zA-Z@.!#$%&'*+\/=?^_`{|}~-]+$/;
	if (re.test(string)){
		return true;
	}
	if (message.length)
		alert(message);
	return false;	
}
function checkMultiEmailPatternFormat(string,message)
{
	if (string == "") return true;
	
	string = string.replace(",",";");
	var vItem = string.split(";");
	for (var i=0;i<vItem.length;i++) {
		if (!checkEmailPatternFormat(vItem[i],"")) {
			if (message.length)
				alert(message + " " + vItem[i]);
			return false;
		}
	}
	return true;
}
function checkDomainNotifyEmailPatternFormat(string,message)
{
	if (string == "") return true;
	
	var re = /^[0-9a-zA-Z@.!#$%&'*+/=?^_`{|}~:-]+$/;
	if (re.test(string))
		return true;

	if (message.length)
		alert(message);
	return false;	
}
function checkMultiDomainNotifyEmailPatternFormat(string,message)
{
	if (string == "") return true;
	
	string = string.replace(",",";");
	var vItem = string.split(";");
	for (var i=0;i<vItem.length;i++) {
		if (!checkDomainNotifyEmailPatternFormat(vItem[i],"")) {
			if (message.length)
				alert(message + " " + vItem[i]);
			return false;
		}
	}
	return true;
}
function checkEmailFormat(string,message)
{
	if (string == "") return true;
	
	var re =  /^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(\*\.)?(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/i;
	if (re.test(string))
		return true;

	if (message.length)
		alert(message);
	return false;	
}

function checkWTPApprovedSendersFormat(string,message)
{
	if (string == "") return true;
	
	var re_domain  = /^(?:[a-z0-9*ẹịọụṣṅ](?:[a-z0-9-ẹịọụṣṅ]*[a-z0-9ẹịọụṣṅ])?\.)+[a-z0-9*ẹịọụṣṅ](?:[a-z0-9-ẹịọụṣṅ]*[a-z0-9ẹịọụṣṅ])?$/i;
	var re_email   = /^([a-z0-9ẹịọụṣṅ!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9ẹịọụṣṅ!#$%&'*+/=?^_`{|}~-]+)*)?@(?:[a-z0-9*ẹịọụṣṅ](?:[a-z0-9-ẹịọụṣṅ]*[a-z0-9ẹịọụṣṅ])?\.)+[a-z0-9*ẹịọụṣṅ](?:[a-z0-9-ẹịọụṣṅ]*[a-z0-9ẹịọụṣṅ])?$/i;
	

	
	if (re_domain.test(string))
	{	
		return true;
	}
	if (re_email.test(string))
	{	
		return true;
	}
	
	if (message.length)
		alert(message);
	return false;	
}

function checkBaseDomainFormat(string,message)
{
	if (string == "") return true;
	
	var re_domain  = /^(?:[a-z0-9*](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9*](?:[a-z0-9-]*[a-z0-9])?$/i;
	if (re_domain.test(string))
		return true;
	
	if (message.length)
		alert(message);
	return false;	
}

function checkFileHashFormat(string, message){
	if (string == "") return false;
	
	var re_keyword = /\b([a-fA-F0-9]{64})\b/;
	
	if (re_keyword.test(string))
		return true;
	
	if (message.length)
		alert(message);
	return false;
	
}

function checkKeywordFormat(string, message){
	if (string == "") return false;
	
	var re_keyword = /^[^*{}!<>`()\s$&\r\n;\\/="%]+$/i;
	
	if (re_keyword.test(string))
		return true;
	
	if (message.length)
		alert(message);
	return false;
	
}
function checkDomainNameFormat(string,message)
{
	if (string == "") return true;
	
	var re_domain  = /([0-9a-z_!~*'()-]+\.)*/;    	
	if (re_domain.test(string))
		return true;	
	if (message.length)
		alert(message);
	return false;	
}
function checkURLFormat(string, message)
{
	if (string == "") return true;
	
	var re = /[hH][tT][tT][pP]([sS]?):\/\/.+/;
	if (re.test(string))
		return true;

	if(message.length)
		alert(message);
	return false;
}
function checkWTPURLFormat(string, message, _null) { // _null: true-can be empty, false-cannot accept empty string
    if (_null == null) _null = true;
	if (_null && (string=="")) return _null;
	var fCheckResult = true;
	
	string = setTrim(string);
	string = string.replace(/^www\./i,"");
	

    // check maximum length of string
    	if(message)
    	{
    		if(!checkInputLength(string,  STR_ERR_URL_LENGTH_INVALID, INT_LMAX_APPROVED_URL ))
	   	{
	   	 	fCheckResult = false;
	   		return fCheckResult;
	   	}	
    	}
	else
	{
		if(!checkInputLength(string, null, INT_LMAX_APPROVED_URL ))
	   	{
	   	 	fCheckResult = false;
	   		return fCheckResult;
	   	}
		
	}
	
	
    	
	
	if(string.indexOf("[")!=-1 && string.indexOf("]")!=-1 )
	{
		string = string.replace("[","");
	//	string = string.replace("]","");
		string = string.replace(/\].*/i,"");
		if(!checkIsIPv6Address(string))
		{
			fCheckResult = false;
		}
	}
	else
	{
		// check lenght of each session
		var vItem = string.split(".");	
		var i = 0;
		while (i < vItem.length) {
			if(message)
			{
				if(!checkInputLength(vItem[i],  STR_ERR_URL_FQDNLENGTH_INVALID, INT_LMAX_APPROVED_URL_FQDNSECTION ))
				{
			   	 	fCheckResult = false;
			    		return fCheckResult;
				}
			}
			else
			{
				if(!checkInputLength(vItem[i], null, INT_LMAX_APPROVED_URL_FQDNSECTION ))
				{
			   	 	fCheckResult = false;
			    		return fCheckResult;
				}
			}	
			i++;		    
		}
		
		// check allowed characters while string has only 1 character
		var re1 = /^[A-Za-z]$/;
		if( string&& string.length == 1 && !re1.test(string))
		    fCheckResult = false;
		
		// check allowed characters of each session
		var re2 = /^\*$/;
	    var re3 = /^[0-9A-Za-zẹịọụṣṅ]+$/;
	    var re4 = /^[0-9A-Za-zẹịọụṣṅ]+([-_]+[0-9A-Za-zẹịọụṣṅ]+)*$/;
		i = 0;
		while (i < vItem.length) {
		    if(vItem[i].length < 0 || !(re2.test(vItem[i])||re3.test(vItem[i])||re4.test(vItem[i])))
		    {
		        fCheckResult = false;
		        break;
		    }
		    i++;
		}
		
		// check "*" only is allowed to appear at the first character
		if(string.lastIndexOf("*") > 0)
		    fCheckResult = false;
		
		if(!fCheckResult)
		{
			if(checkIPAddressFormat(string,"",false,false))
			{
				 fCheckResult = true;
			}
		}
	}
	if(!fCheckResult && message)
	{
	       if(message.length) alert(message);
	}
	
	return fCheckResult;
}

function checkIsIPv6Address(str) {

	if (str.match(/^((([0-9A-Fa-f]{1,4}:){7}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){6}:[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){5}:([0-9A-Fa-f]{1,4}:)?[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){4}:([0-9A-Fa-f]{1,4}:){0,2}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){3}:([0-9A-Fa-f]{1,4}:){0,3}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){2}:([0-9A-Fa-f]{1,4}:){0,4}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){6}((\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b)\.){3}(\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b))|(([0-9A-Fa-f]{1,4}:){0,5}:((\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b)\.){3}(\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b))|(::([0-9A-Fa-f]{1,4}:){0,5}((\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b)\.){3}(\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b))|([0-9A-Fa-f]{1,4}::([0-9A-Fa-f]{1,4}:){0,5}[0-9A-Fa-f]{1,4})|(::([0-9A-Fa-f]{1,4}:){0,6}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){1,7}:)|(::))$/) == null) {
		return false;
	}

	return true;
}

/*
function checkIsIPv6Address(str)  
{ 
	if (str.match(/:/g) == null)
		return false;
	if(str.match(/^::/g) && str.match(/^::/g).length == 1 && str.match(/:/g)&&str.match(/:/g).length == 2 && str.match(/\./g) && str.match(/\./g).length == 3)
	{		
		var re = /^(::)(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
		if(re.test(str)) {
		re.exec(str);
		if((RegExp.$2 >= 1) && (RegExp.$2 <= 255) && (RegExp.$3 >= 0) && (RegExp.$3 <= 255) && (RegExp.$4 >= 0) && (RegExp.$4 <= 255) &&  (RegExp.$5 >= 0) && (RegExp.$5 <= 255)&&(str != "0.0.0.0") && (str != "255.255.255.255"))
			return true;
		}	
	}
	if(str.match(/^::/g)&&str.match(/^::/g).length == 1  &&str.match(/:/g)&&str.match(/:/g).length == 2)
	{
		return /^(::)[\da-f]{1,4}(%\d{1,3}){0,1}$/i.test(str);
	}
	
	if(str.match(/:/g)&& str.match(/:/g).length<=7 && str.match(/::/g)&& str.match(/::/g).length == 1)
	{
		if(false == /^([\da-f]{1,4}(:|::)){1,6}[\da-f]{1,4}(%\d{1,3}){0,1}$/i.test(str))
		{
		    if(false == /^(::){1}([\da-f]){1,4}(:){1}(([\da-f]){1,4}(:){1}){0,5}(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/i.test(str))
		    {
		        if(false ==  /^(([\da-f]){1,4}(:){1}){0,4}([\da-f]){1,4}(::){1}(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/i.test(str))
		        {
		            return /^(([\da-f]){1,4}(:){1}){0,3}(([\da-f]){1,4}){1}(::){1}(([\da-f]){1,4}(:){1}){0,4}(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/i.test(str)
		        }
		    }
		}
		return true;
	}
	else
	{
	    return /^([\da-f]{1,4}:){7}[\da-f]{1,4}(%\d{1,3}){0,1}$/i.test(str);
	} 
}
*/

function checkIPAddressFormat(string, message, _null, DisallowIPv6) // _null: true-can be empty, false-cannot accept empty string
{
	if (_null==null) _null = true;
	if (DisallowIPv6 == null) DisallowIPv6 = false;
	if (_null && (string=="")) return _null;

//If the address is IPv6 and we don't support (NoIPv6=true), prompt warnning message	
	if(checkIsIPv6Address(string)) {
		if (DisallowIPv6){
			if(message && message.length)
				alert(message+"_IPv6");
			return false;
		}
		else
			return true;
	}
	
	var re = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
	//var re1 = /^[\w-]+\.[\w-]+\.[\w-]+\.[\w-]*$/;
	if(re.test(string)) {
		re.exec(string);
		if((RegExp.$1 >= 1) && (RegExp.$1 <= 255) && (RegExp.$2 >= 0) && (RegExp.$2 <= 255) && (RegExp.$3 >= 0) && (RegExp.$3 <= 255) && (RegExp.$4 >= 0) && (RegExp.$4 <= 255) && (string != "0.0.0.0") && (string != "255.255.255.255"))
			return true;
	}	
	//else if (re1.test(string)) {
	//	return true;
	//}
	
//	if(message.length)
//		alert(message);
	if(message &&message.length)
		eval( "alert(" + message + ")" );
	return false;
}

function checkPortRange(string ,message)
{
    if ( string>=1 && string<=65535 )
    	return  true;
    	
    if(message.length)
		alert(message);
    return  false;
}
function checkPathFormat(string, message, _null) // _null: true-can be empty, false-cannot accept empty string
{
	if (_null==null) _null = true;
	if (_null && (string=="")) return _null;

	if (string.charAt(string.length-1) != "\\") {
		string += "\\";
	}
//	var re = /^[a-zA-Z]:\\([^\/\\:*?"<>|]{1,200}\\)+([^\/\\:*?"<>|]{1,200}\\?)$/;
	var re = /^[a-zA-Z]:\\([^\/\\:*?"<>|]{0,200}\\)*$/;
	if(re.test(string) && checkFolderName(string))
		return true;
	
	if(message.length)
		alert(message);
	return false;
}
function checkUNCPathFormat(string, message)
{
	if (string == "") return true;
	
	var re = /(\;)?\\{2,}/g;
	if(re.test(string) && checkFolderName(string))
	{
		var toks = string.split("\\");
	    var ipAddress = toks[2];
	
	    if(checkIsIPv6Address(ipAddress))
	    {
	        if(message.length)
		    alert(message);
		    return false;
	    }
	    return true;
	}
		
	if(message.length)
		alert(message);
	return false;
}
function checkFolderName(string)
{
   var toks = string.split("\\");
   for(var i=0;i<toks.length;i++){
       if(toks[i] != "." && toks[i] != ".." && toks[i].length> 0){
            if((toks[i].charAt(0)==".") || (toks[i].charAt(0)==" ") || (toks[i].charAt(toks[i].length-1)==".") || (toks[i].charAt(toks[i].length-1)==" "))
                return false;
       }
   }
   return true;
}
function checkFileNameFormat(string,message,_max,_min,_null) // _null: An empty string is allowed (true) or not allowed (false).
{
	if (_null == null) _null = true;
	if (_null && (string=="")) return _null;
	
	if (_max == null) _max = INT_LMAX_FILENAME;
	if (_min == null) _min = 1;
	
	if (checkNumberRange(string.length,_max,_min,"") && 
	   (string.charAt(0)!=".") && (string.charAt(string.length-1)!=".")) {
		var re = /^[^\/\\:"<>|*?]+$/;
		if(re.test(string))
			return true;
	}

	if(message.length)
		alert(message);
	return false;
}
function checkAttachFileName(string,message,_max,_min,_null) // _null: An empty string is allowed (true) or not allowed (false).
{
	if (_null == null) _null = true;
	if (_null && (string=="")) return _null;
	
	if (_max == null) _max = INT_LMAX_FILENAME;
	if (_min == null) _min = 1;
	
	if (checkNumberRange(string.length,_max,_min,"") && 
	   (string.charAt(0)!=".") && (string.charAt(string.length-1)!=".")) {
		var re = /^[^|]+$/;
		if(re.test(string))
			return true;
	}

	if(message.length)
		alert(message);
	return false;
}
function checkReplaceFileNameFormat(string, message,_null) // _null: An empty string is allowed (true) or not allowed (false).
{
	if (_null == null) _null = true;
	if (_null && (string=="")) return _null;
	
	if ((string.charAt(0)!=".") && (string.charAt(string.length-1)!=".")) {
		var re = /^[^\/\\:"<>|*?]+$/;
		if(re.test(string))
			return true;
	}
	
	if(message.length)
		alert(message);
	return false;
}
function checkExtensionFormat(string, message,_null) // _null: An empty string is allowed (true) or not allowed (false).
{
	if (_null == null) _null = true;
	if (_null && (string=="")) return _null;
	
	if ((string.charAt(0)!=".") && (string.charAt(string.length-1)!=".")) {
		var re = /^[^\/\\:"<>;|]+$/;
		if(re.test(string))
			return true;
	}
	
	if(message.length)
		alert(message);
	return false;
}
function checkLongExtensionFormat(string, message)
{
	if (string == "") return true;
	
	if (checkNumberRange(string.length,INT_LONG_EXTENSION_MIN,INT_LONG_EXTENSION_MAX,""))
		return true;
	
	if(message.length)
		alert(message);
	return false;
}
function checkReplaceContentFormat(string, message)
{
	if (checkNumberRange(string.length,INT_REPLACE_CONTENT_MAX,INT_REPLACE_CONTENT_MIN,""))
		return true;
	
	if(message.length)
		alert(message);
	return false;
}

function checkNumberRange(num, max, min, message, _null) // _null: true-can be empty, false-cannot accept empty string
{
	if (_null==null) _null=true;
	if (_null && ((num.toString()=="")||num==0)) return _null;
	
	if(_null || !(num.toString()=="" || num==0)){
	    if (min>max) {
          var temp = min;
          min = max;
          max = temp;
        }
        if (checkNumber(num, "") && num <= max && num >= min)
    	    return true;
    }
    
    if(message && message.length)
    {
    	message = message.replace("%MAX",max);
    	message = message.replace("%MIN",min);
		alert(message);
	}
	return false;
}

function checkNumberRangeV2(num, max, min, message, _null) // _null: true-can be empty, false-cannot accept empty string
{
	if (_null==null) _null=true;
	if (_null && (num.toString()=="")) return _null;
	
	if(_null || !(num.toString()=="" || num==0)){
	    if (min>max) {
          var temp = min;
          min = max;
          max = temp;
        }
        if (checkNumber(num, "") && num <= max && num >= min)
    	    return true;
    }
    
    if(message.length)
    {
    	message = message.replace("%MAX",max);
    	message = message.replace("%MIN",min);
		alert(message);
	}
	return false;
}

// test for a decimal positive number
function checkNumber(num, message)
{
	//var re = /^[0-9]+$/;
	var re = /^(0|[1-9][0-9]*)$/;
	if(re.test(num))
		return true;
	
	if(message.length)
		alert(message);
	return false;
}
// test for a decimal positive number and the maximum limit
function checkNumberNSize(num, max, message, _null) // _null: true-can be empty, false-cannot accept empty string
{
	if (_null==null) _null=true;
	if (_null && ((num.toString()=="") || num==0)) return _null;
	
	//var re = /^[0-9]+$/;
	var re = /^(0|[1-9][0-9]*)$/;	
	
	if(re.test(num) && num <= max)
		return true;
	
	if(message.length)
		alert(message);
	return false;
}
function checkInputLength(string, message, max_length)
{
	if(string.length && (string.length > max_length))
	{
		if(message)
		{	
			alert(message);	
		}
		return false;
		
	}
	return true;
}
function checkURLLength(string, message)
{
	if(string.length && (string.length > 256))
	{
		alert(message);
	
		return false;

	}
	return true;
}
function checkUNCPathLength(string, message)
{
	
	if(string.length && (string.length > 256))
	{
		alert(message);
	
		return false;

	}
	return true;
}

function checkDisplayNameFormat(string, message, _null) // _null: true-can be empty, false-cannot accept empty string
{
	if (_null == null) _null = true;
	if (_null && (string=="")) return _null;
	
	var re = /^[^",;()<>]+$/;
	if(re.test(string))
		return true;
	
	if(message.length)
		alert(message);
		
	return false;
}

function checkEntityDisplayNameFormat(string, message, _null) // _null: true-can be empty, false-cannot accept empty string
{
	if (_null == null) _null = true;
	if (_null && (string=="")) return _null;
	
	var re = /^[^\/\"<>]+$/;
	if(re.test(string))
		return true;
	
	if(message.length)
		alert(message);
		
	return false;
}
function checkADUserName(string, message, _null) // _null: true-can be empty, false-cannot accept empty string
{
    string = setTrim(string);
    if (_null == null) _null = true;
	if (_null && (string=="")) return _null;
	
	var re = /^[^\/\\\[\]:;|=,\*\+\?<>@"]+$/;
	if(re.test(string))
		return true;
	
	if(message.length)
		alert(message);
		
	return false;
}

function checkADUserNamewithDomain(string, message, _null) // _null: true-can be empty, false-cannot accept empty string
{
    string = setTrim(string);
    if (_null == null) _null = true;
	if (_null && (string=="")) return _null;
	
	var re = /^[^\/\[\]:;|=,\*\+\?<>@"]+$/;
	if(re.test(string) && string.indexOf("\\") == string.lastIndexOf("\\"))
		return true;
	
	if(message.length)
		alert(message);
		
	return false;
}
/* ================================================================================== */
/* Flatform Issue                                                                                              																	  */
/* ================================================================================== */

// emulates IE's innertext on Firefox's Proprietary __defineGetter__ 
if (typeof HTMLElement != "undefined" && typeof HTMLElement.prototype.__defineGetter__ != "undefined")
{
  HTMLElement.prototype.__defineGetter__("innerText", function ()
  {
    if (this.textContent)
    {
    	return(this.textContent)
    }
    else
    {
    	var r=this.ownerDocument.createRange();
    	r.selectNodeContents(this);
    	return r.toString();
    }
  });
  HTMLElement.prototype.__defineSetter__("innerText", function (sText) 
  {
    if  (this.textContent)
    {
    	this.textContent = sText;
    }
    else
    {
    	this.innerHTML = sText.replace(/\&/g, "&").replace(/\>/g, ">");
    }
  });
}

/* ================================================================================== */
/* SMEX 7.0 2004Q3																	  */
/* ================================================================================== */
function jsDisplayStep(sTarget,curItem,nxtItem) {
	// just for multiple items in one page
	if (sTarget.length == 0) {return;}
	if (document.getElementById(sTarget+curItem) == null) {return;}
	if (document.getElementById(sTarget+nxtItem) == null) {return;}

	document.getElementById(sTarget+curItem).style.display = "none";
	document.getElementById(sTarget+nxtItem).style.display = "";
}
function jsOpenHelp(sURL) {
	// init variant
	var vSession, vKey, vStamp;
	var allcookie = unescape(document.cookie);
	var CookiePair = allcookie.split(";");
	for(i=0;i<CookiePair.length;i++){
        if(CookiePair[i].indexOf("session=") != -1){
            vSession = CookiePair[i].substring(CookiePair[i].indexOf("=")+1,CookiePair[i].length);
        }
        else if(CookiePair[i].indexOf("key=") != -1){
            vKey = CookiePair[i].substring(CookiePair[i].indexOf("=")+1,CookiePair[i].length);
        }
        else if(CookiePair[i].indexOf("stamp=") != -1){
            vStamp = CookiePair[i].substring(CookiePair[i].indexOf("=")+1,CookiePair[i].length);
        }
    }
	
	var sBase = "../smex/online_help/";
	var sName = "SMEX_HELP_" + vSession + "_" + vKey + "_" + vStamp;
	
	sURL = sBase + sURL;
	var rv = window.open(sURL,sName,"toolbar=no,menubar=no,directories=no,scrollbars=yes,resizable=yes,dependent=yes");
	rv.opener = self;
	
	// resize window
	rv.resizeTo((screen.availWidth*6)/10+1, screen.availHeight);
	rv.moveTo((screen.availWidth*4)/10, 0);
	rv.focus();
}
function jsCheckLoginLocation() {
    if (window.name=="smex_main")
        parent.location.href = "Login.htm";
    else
        document.location.href = "Login.htm";
}
function jsTrim(oStr){
	return oStr.value.replace(/(^\s*)|(\s*$)/g, "");
}


/* ================================================================================== */
/* SMEX 8.0 2006Q3																	  */
/* ================================================================================== */

function objTable(tableid,numcolumn){
    this.id = tableid;
    this.column =  numcolumn;
}

function method_addTableRow(srcString,sClassName,eClassName){
    
    if (sClassName == null) return;
    if (eClassName == null) eClassName = sClassName;
    var tableid = this.id;
   
    var row = document.createElement("TR");
    row.height = 20; 
    var strBlank = (vBrowser == "IE")?"&nbsp;":"";
    var oString = srcString.split("|"); 
    var numcolumn = this.column;
    var cClassName,CellText,cell;
    var cell;
  
    for(var i=0;i<numcolumn;i++){
	    cClassName = (i == (numcolumn - 1))?eClassName:sClassName;    
	    if(i<oString.length){
	        CellText = (oString[i] == "")?strBlank:oString[i];
	    }
	    else{
	        CellText = strBlank;
	    }  
	    cell = this.addTableCell(CellText,cClassName);
	    row.appendChild(cell);
	}
  	var tableNode = document.getElementById(tableid);
  	for(i=0;i<tableNode.childNodes.length;i++){
  	    if(tableNode.childNodes[i].tagName == "TBODY"){
  	        var tbodyNode = tableNode.childNodes[i];
  	        break;
  	    }
  	}
  	
    tbodyNode.appendChild(row);
}

function method_addTableCell(CellText,CellClassName){
	var cell = document.createElement("TD");
	if (vBrowser == "IE" || vBrowser == "FX") {
	    cell.innerHTML = CellText;
	}else{
	    cell.innerText = CellText;
	}	
	cell.className = CellClassName;
	
	return cell;
}

function method_clearTableContent(){		
	var tableNode = document.getElementById(this.id);
	var NumTableChildren = tableNode.childNodes.length;
	for(i=0;i<NumTableChildren;i++){
  	    if(tableNode.childNodes[i].tagName == "TBODY"){
  	        var tbodyNode = tableNode.childNodes[i];
  	        break;
  	    }
  	}
	var contentRowNum = tbodyNode.childNodes.length;	
	if(contentRowNum>1){
	    for(i=1;i<contentRowNum;i++){
	    	tbodyNode.removeChild(tbodyNode.childNodes[1]);
	    }
	}
}

function method_getRowAmount(){
    var tableNode = document.getElementById(this.id);
  	for(i=0;i<tableNode.childNodes.length;i++){
  	    if(tableNode.childNodes[i].tagName == "TBODY"){
  	        var tbodyNode = tableNode.childNodes[i];
  	        break;
  	    }
  	}
  	return tbodyNode.childNodes.length;
}
/*method_insertElement: Insert element to certain (row,column)
    elmType: the type of element
    nRow: the number of target row, start from 0
    nCol: the number of target column, start from 0
    strId: the value of element's ID
    strName: the value of element's NAME
*/
function method_insertElement(elmType,nRow,nCol,strId,strName,strOtherSetting){    
    var newElement;
    var tableNode = document.getElementById(this.id);
    var NumTableChildren = tableNode.childNodes.length;
	for(i=0;i<NumTableChildren;i++){
  	    if(tableNode.childNodes[i].tagName == "TBODY"){
  	        var tbodyNode = tableNode.childNodes[i];
  	        break;
  	    }
  	}
	//insert a checkbox
	if (elmType == "CHECKBOX") {	    
	    newElement = document.createElement("INPUT");
	    if(strId != null) newElement.id = strId;
	    if(strName != null) newElement.name = strName;
	    newElement.type = "checkbox";
	}
	//insert a image
	if (elmType == "IMAGE") {
	    newElement = document.createElement("IMG");
	    if(strId != null) newElement.id = strId;
	    if(strName != null) newElement.name = strName;
	    if(strOtherSetting == null){ return false; }
	    else{ newElement.src = strOtherSetting;}
	}
	var trgNode = tbodyNode.childNodes[nRow].childNodes[nCol];
	trgNode.appendChild(newElement);
	return newElement;
}

new objTable("",0);
objTable.prototype.addTableRow = method_addTableRow;
objTable.prototype.addTableCell = method_addTableCell;
objTable.prototype.clearTableContent = method_clearTableContent;
objTable.prototype.insertElement = method_insertElement;
objTable.prototype.getRowAmount = method_getRowAmount;

function showMoreInfo(miIframe,miObject,miWidth,miHeight,miTitle,miContent){
    var nTop=miObject.offsetTop;
    var nLeft=miObject.offsetLeft;
    while(miObject=miObject.offsetParent){
        nTop+=miObject.offsetTop;
        nLeft+=miObject.offsetLeft;
    }
	var nPadding = 15;
	var nScroll  = (vBrowser=="NN")?15:18;
	var yScroll  = document.body.scrollTop;
	var nW_Width = document.documentElement.offsetWidth;
	var nW_Height= (vBrowser=="FX")?window.innerHeight:document.documentElement.offsetHeight;
	
	if(nW_Height + yScroll - (nTop + miHeight + nPadding)<0){
	    nTop = nTop - (miHeight + 5);
	}
	else{
	    nTop = nTop + nPadding;
	}
	
	document.getElementById(miIframe).style.top=(nTop>0)?nTop:0;
	document.getElementById(miIframe).style.left=nLeft;
	document.getElementById(miIframe).style.width=miWidth;
	document.getElementById(miIframe).style.height=miHeight;
	window.frames[miIframe].jsSendiFrameName(miIframe);	
	window.frames[miIframe].jsInsertContent(miTitle,miContent);
	    
    document.getElementById(miIframe).style.display = "";
}
function concealMoreInfo(miIframe){
    document.getElementById(miIframe).style.display = "none";
}
function jsTagInit(vcPage,vPageTags){
    var allcookie = unescape(document.cookie);
    var CurrentPage,CurrentTag;
    aryPageTags = vPageTags.split(";"); 
    if(allcookie.indexOf("page=") != -1 && allcookie.indexOf("currenttag=") != -1){
        var CookiePair = allcookie.split(";");
        for(i=0;i<CookiePair.length;i++){
            if(CookiePair[i].indexOf("page=") != -1){
                CurrentPage = CookiePair[i].substring(CookiePair[i].indexOf("=")+1,CookiePair[i].length);
            }
            else if(CookiePair[i].indexOf("currenttag=") != -1){
                CurrentTag = CookiePair[i].substring(CookiePair[i].indexOf("=")+1,CookiePair[i].length);
                PageCurrentTag = CurrentTag;
            }
        }
        document.cookie = "page=" + escape("");
        document.cookie = "currenttag=" + escape("");
    }
    if(CurrentPage != null && CurrentTag != null){
        if(CurrentPage ==vcPage && CurrentTag !=""){ 
            for(var i=0;i<aryPageTags.length;i++){
                if(aryPageTags[i] == CurrentTag)
                     setUITagDisplay(i+1,aryPageTags.length,aryPageTags[i]);
            }
        }
    }
      
	if(!PageCurrentTag){
	    PageCurrentTag=aryPageTags[0];
	}
}
function jsSaveCookie(vcPage){
    if(window.location.search.indexOf("&",window.location.search.indexOf("Subject=")+8)>-1){
	    winSubject = window.location.search.substring((window.location.search.indexOf("Subject=")+8),window.location.search.indexOf("&",window.location.search.indexOf("Subject=")+8));
	}
	else{
	    winSubject = window.location.search.substring((window.location.search.indexOf("Subject=")+8),window.location.search.length);
	}
    if(winSubject.indexOf("SS") == -1 && winSubject.indexOf("MS") == -1){
        document.cookie = "page=" + escape(vcPage);
        document.cookie = "currenttag=" + escape(PageCurrentTag);
    } 
}
function getCookie(name)
{
   var strCookie=document.cookie; 
   var arrCookie=strCookie.split("; "); 
   for(var i=0;i<arrCookie.length;i++){ 
       var arr=arrCookie[i].split("="); 
       if(arr[0]==name)return unescape(arr[1]); 
   }
}
function setCookie(name,value)
{
    document.cookie=name+"="+escape(value);
}
function deleteOneCookie(name)
{
    var exp = new Date();
    exp.setDate(exp.getDate() - 1);
    
    var cval=getCookie(name);    
    setCookie(name,"");//clear cookie content, then set it expire.
    
    if(cval!=null) 
    document.cookie= name + "="+cval+"; expires="+exp.toGMTString()+ "; " ;
}
function createXMLHttpRequest() {
    try { return new ActiveXObject("Msxml2.XMLHTTP"); } catch (e) {}
    try { return new ActiveXObject("Microsoft.XMLHTTP"); } catch (e) {}
    try { return new XMLHttpRequest(); } catch(e) {}
    return null;
}

function DecorateDateFormat(original)
{
	//trim
	original = original.replace(/(^\s*)|(\s*$)/g, "");

	var newFormat;
	
	var dateParts;
	var splitChar;
	var i;
	var splitChars = new Array(2);
	splitChars[0] = new Array(2);
	splitChars[1] = new Array(2);

	for(i=0;i<2;i++)
	{
		if(original.indexOf("/")>-1)
		{
			splitChars[i][0]=original.indexOf("/");
	        splitChars[i][1]="/";
	    	original=original.replace("/","*");    
		}
    	else if(original.indexOf("-")>-1)
    	{
        	splitChars[i][0]=original.indexOf("-");
	        splitChars[i][1]="-";
	    	original=original.replace("-","*");   
    	}else if(original.indexOf(".")>-1)
    	{
    		splitChars[i][0]=original.indexOf(".");
	        splitChars[i][1]=".";
	    	original=original.replace(".","*");   
    	}else if(original.indexOf(" ")>-1){
    		splitChars[i][0]=original.indexOf(" ");
	        splitChars[i][1]=" ";
	    	original=original.replace(" ","*");   
    	}
	}

	dateParts = original.split("*");

	//swap char
	if(splitChars[0][0]>splitChars[1][0])
	{
		var temp = splitChars[1];
		splitChars[1]=splitChars[0];
		splitChars[0]=temp;
	}
    
	if(dateParts.length == 3)
	{
	    for( var i=0; i<3; i++ )
	    {
	        var tmp = dateParts[i];
	        if(tmp.length == 1 && (tmp.toLowerCase()=="m"||tmp.toLowerCase()=="d") )
	        {
	            dateParts[i] = dateParts[i] + dateParts[i];
	        }        
	    }
	    newFormat = dateParts[0] + splitChars[0][1] + dateParts[1] + splitChars[1][1] + dateParts[2];
	}
	return newFormat;
}
//Joined several strings into one string, and these sub string was begin with the length. The string was used to separate string by length. 
function jsJoinStringWithLen(vecParams)
{
        var retValue="";
        
        //the first 8 bytes used to recode the lenght of each item.
        for(var i=0;i<vecParams.length;i++)
        {
            var iLen=vecParams[i].length;
	    var nLen=iLen;
	    var j=0;
	    while(parseInt(iLen)/10!=0) 
            {
                iLen=parseInt(iLen)/10;
                j++;
            }
            for(;j<8;j++)       
                retValue+=" ";
            retValue+=nLen;
            retValue+=vecParams[i];
        }
        return retValue;
}
function jsSeparateStringWithLen(Str,vecString)
{
        //the first 8 bytes used to recode the lenght of each item.
        var start=0;
        var end=8;
        var i=0;
        var iLen=setTrim(Str.substring(start,end));
        while(iLen!=0)
        {     
                start=parseInt(end);  
                end=parseInt(end)+parseInt(iLen);  
                var Item=Str.substring(start,end);
                vecString[i++]=Item;
                start=parseInt(end); 
                end=parseInt(end)+8;   
                iLen=setTrim(Str.substring(start,end));   
        }
}

//to decide whether the variable is defined
function jsIsDefined(param)
{
	if(param==""||param==null||param=="undefined")
	        return false;
	else 
		return true;
}

function jsConstructSP(Account, AccountType, ContentToShow)//for "Anyone", the AccountType is 1, ContentToShow is 3
{
	var result="";
	if(Account)
	{
		var Len= (Account.length+4).toString(); //comments for "4": Tab+AccountType+Tab+ContentToShow. Result example:"      10Anyone	0	3"
		for(var i=0;i<8-(Len).length;i++)
		{
			result = result +" ";
		}		
		result = result+Len;
		result = result+Account;
		result = result+"	";
		result = result+AccountType.toString();
		result = result+"	";
		result = result+ContentToShow.toString();
	}
	return result;
}

function jsChangeNotifyAdmin()
{
	 //Administrator Notification
	document.getElementById("txtNotifyAdminTo1").disabled = (!document.getElementById("chkNotifyAdmin").checked);
	document.getElementById("txtNotifyAdminSubject").disabled = (!document.getElementById("chkNotifyAdmin").checked);
	document.getElementById("optAdminMessageType").disabled = (!document.getElementById("chkNotifyAdmin").checked);
	document.getElementById("txtNotifyAdminMessage").disabled = (!document.getElementById("chkNotifyAdmin").checked);
	var settingRadio = document.getElementsByName("optNotifyAdminSettings");
	for(var i = 0;i<settingRadio.length;i++)
	    settingRadio[i].disabled= (!document.getElementById("chkNotifyAdmin").checked);	
	document.getElementById("txtNotifyAdminSettingsPeriod").disabled = (!document.getElementById("chkNotifyAdmin").checked);
	document.getElementById("optNotifyAdminSettingsPeriodUnit").disabled = (!document.getElementById("chkNotifyAdmin").checked);
	document.getElementById("txtNotifyAdminSettingsOccurence").disabled = (!document.getElementById("chkNotifyAdmin").checked);
}

var g_L10NVariables = new Array();
function replaceTdTitle(obj)
{
	for (var i = 0; i< g_L10NVariables.length; ++i)
	{
		for(var j in g_L10NVariables[i])
		{
			if (j == "PAGE_TITLE")
				document.title = g_L10NVariables[i][j];
			else
				obj.setAttribute("title", obj.getAttribute("title").replace("(##" + j + ")", g_L10NVariables[i][j]));
		}
	}
}
function replaceInputValue(obj)
{
	for (var i = 0; i< g_L10NVariables.length; ++i)
	{
		for(var j in g_L10NVariables[i])
		{
			if (j == "PAGE_TITLE")
				document.title = g_L10NVariables[i][j];
			else
				obj.setAttribute("value", obj.getAttribute("value").replace("(##" + j + ")", g_L10NVariables[i][j]));
		}
	}
}
function replaceInnerText(obj)
{
	for (var i = 0; i< g_L10NVariables.length; ++i)
	{
		for(var j in g_L10NVariables[i])
		{
			if (j == "PAGE_TITLE")
				document.title = g_L10NVariables[i][j];
			else
				obj.nodeValue = obj.nodeValue.replace("(##" + j + ")", g_L10NVariables[i][j]);
		}
	}
}

function traverseDomNode(obj)
{
	var _tempNodes = obj.childNodes;
	if(_tempNodes == null || _tempNodes.length == 0)
	{
		return null;
	}
	else
	{
		for(var i=0;i<_tempNodes.length;i++)
		{
			var childNode = _tempNodes[i].childNodes;
			if(childNode == null || childNode.length == 0)	//none composite tag
			{
				if(_tempNodes[i].tagName != null)
				{
					if(_tempNodes[i].tagName.toLowerCase() == "input")
					{
						if((_tempNodes[i].getAttribute("value") != null) && (_tempNodes[i].getAttribute("value").indexOf("(##") != -1))
						{
							replaceInputValue(_tempNodes[i]);
						}
					}
					else if(_tempNodes[i].tagName.toLowerCase() == "td")
					{
						if((_tempNodes[i].getAttribute("title") != null) && (_tempNodes[i].getAttribute("title").indexOf("(##") != -1))
						{
							replaceTdTitle(_tempNodes[i]);
						}
					}
				}
				else if(_tempNodes[i].nodeValue != null)
				{	
					if((_tempNodes[i].nodeValue != null) && (_tempNodes[i].nodeValue.indexOf("(##") != -1))
					{
						replaceInnerText(_tempNodes[i]);
					}
				}
			}
			else	//composite tag
			{
				if((_tempNodes[i].tagName != null))
				{
					if(_tempNodes[i].tagName.toLowerCase() == "td")
					{
						if((_tempNodes[i].getAttribute("title") != null) && (_tempNodes[i].getAttribute("title").indexOf("(##") != -1))
						{
							replaceTdTitle(_tempNodes[i]);
						}
					}
					traverseDomNode(_tempNodes[i]);
				}
			}
		}
	}
}
		
function renderL10NText()
{
	traverseDomNode(document.body);
	if(document.body!=null) document.body.style.visibility="visible";//for UI optimize, page will be hidden before this to avoid show "(##key)".
	//if(parent.document.body!=null) parent.document.body.style.visibility="visible";
	//if(document.body!=null) document.body.style.display="block";
	//if(parent.document.body!=null) parent.document.body.style.display="block";
}

//if select tag information doesn't show all,add this function in html.
function resetSelectWidth()
{
   var select=document.getElementsByTagName("select");
   for(var i=0;i<=select.length;i++)
   {
      var s=select[i];
	  if(s!=null)
	  {
	     s.style.width='auto';
	  }
   }
}

// get unique array
function uniqueArray(array) {
    var a = array.concat();
    for(var i=0; i<a.length; ++i) {
        for(var j=i+1; j<a.length; ++j) {
            if(a[i] === a[j])
                a.splice(j--, 1);
        }
    }
    return a;
}

function jsAddCSRFToken(oForm)
{
	var strToken = getCookie("CSRFToken");
	var varInput = document.createElement("input");
	varInput.setAttribute("type", "hidden");
    varInput.setAttribute("name", "CSRFToken");
    varInput.setAttribute("value", strToken);
	oForm.appendChild(varInput);
}